<?php
// Exit if accessed directly
if (!defined('ABSPATH')) exit;
add_action('admin_menu', 'dbx_innoship_admin_menu');
function dbx_innoship_admin_menu(){
    add_options_page( esc_html__('Setări Innoship', 'woo-dbx-innoship' ), esc_html__('Innoship', 'woo-dbx-innoship' ), 'manage_options', 'dbx-innoship-settings-page','dbx_innoship_options_page' );
}
add_action('admin_init', function() {
    register_setting( 'dbx-innoship-settings-group', 'dbx-innoship-plugin-settings' );
  	add_settings_section( 'dbx-innoship-settings-section', esc_html__( 'Setări Innoship', 'woo-dbx-innoship' ), 'dbx_innoship_settings_callback', 'dbx-innoship-settings-page' );
  	add_settings_section( 'adv-section', esc_html__( 'Dabex Agency', 'woo-dbx-innoship' ), 'dbx_innoship_adv_callback', 'dbx-innoship-adv-page' );
  	add_settings_field( 'dbx_innoship_auth_key', ' ', 'dbx_innoship_auth_key_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' );
  	add_settings_field( 'dbx_innoship_validate', ' ', 'dbx_innoship_validate_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' );
  	add_settings_field( 'dbx_innoship_activation_id', '', 'dbx_innoship_activation_id_callback', 'dbx-innoship-settings-page', 'innoship-dpd-settings-section' );
  	add_settings_field( 'dbx_innoship_api_key', ' ', 'dbx_innoship_api_key_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' );
  	add_settings_field( 'dbx_innoship_external_location', ' ', 'dbx_innoship_external_location_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' );
  	add_settings_field( 'dbx_innoship_serviciu', ' ', 'dbx_innoship_serviciu_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' );
  	add_settings_field( 'dbx_innoship_tip_plata', ' ', 'dbx_innoship_tip_plata_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' );
  	add_settings_field( 'dbx_innoship_platitor', ' ', 'dbx_innoship_platitor_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' );
  	add_settings_field( 'dbx_innoship_ls', ' ', 'dbx_innoship_ls_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' );
  	add_settings_field( 'dbx_innoship_dc', ' ', 'dbx_innoship_dc_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' );
  	add_settings_field( 'dbx_innoship_format_awb', ' ', 'dbx_innoship_format_awb_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' );
  	add_settings_field( 'dbx_innoship_nr_colete', ' ', 'dbx_innoship_nr_colete_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' );
  	add_settings_field( 'dbx_innoship_livrare','', 'dbx_innoship_livrare_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' ); 
  	add_settings_field( 'dbx_innoship_pickup','', 'dbx_innoship_pickup_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' ); 
  	add_settings_field( 'dbx_innoship_autogenerate','','dbx_innoship_autogenerate_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' );
  	add_settings_field( 'dbx_innoship_update_comanda','', 'dbx_innoship_update_comanda_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' ); 
    add_settings_field( 'dbx_innoship_update_mail','','dbx_innoship_update_mail_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' ); 
    add_settings_field( 'dbx_innoship_text_mail','', 'dbx_innoship_text_mail_callback', 'dbx-innoship-settings-page', 'dbx-innoship-settings-section' ); 
  	include_once (DBX_INNOSHIP_PLUGIN_PATH.'/admin/settings-template.php');
});
function dbx_innoship_options_page(){
    ?>
    <div class="wrap-settings">
      <div class="dbx-innoship-settings-section">
      <form action="options.php" method="POST">
        <?php settings_fields('dbx-innoship-settings-group'); ?>
        <?php do_settings_sections('dbx-innoship-settings-page'); ?>
        <?php submit_button(); ?>
      </form>
      </div>
      <div class="adv-section">
      <?php do_settings_sections('dbx-innoship-adv-page'); ?>          
      </div>    
    </div>
    <?php
}
add_action( 'admin_print_styles-settings_page_dbx-innoship-settings-page', 'dbx_innoship_style', 11 );
function dbx_innoship_style(){
       if ( is_admin() ) {
        wp_register_style("dbx_innoship_style", plugins_url('assets/dbx_innoship.css', __FILE__), false, "1.0.0");
        wp_enqueue_style( 'dbx_innoship_style' );
        wp_register_style( 'dbx_innoship_select2', 'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.8/css/select2.min.css', false, '4.0.8');
        wp_enqueue_style( 'dbx_innoship_select2' );
        wp_enqueue_script('dbx_select2', 'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.8/js/select2.min.js', array('jquery'), '4.0.8', true);
        //wp_enqueue_script('dbx_auth', plugins_url('assets/js/dbx_auth.js', __FILE__), array('jquery'), '1.0.0', true);
        } 
}