<?php
add_action('wp', function () {
    if (!wp_next_scheduled('innoship_status_update')) {
        wp_schedule_event(time(), 'twicedaily', 'innoship_status_update');
    }
});
add_action('innoship_status_update', 'update_status_innoship');
function update_status_innoship(){
    global $wpdb;
    $key      = 'awb_status';
    $value    = '100';
    $orders = $wpdb->get_results($wpdb->prepare("SELECT * FROM " . $wpdb->postmeta . " WHERE meta_key=%s AND meta_value!=%s", $key, $value));
    if(count($orders)){
        foreach($orders as $ord){
            $awb_id = get_post_meta($ord->post_id,'awb_innoship', true);
            $awbs []= $awb_id;
            if(empty($awb_id)) continue;
            $courier_id = get_post_meta($ord->post_id,'innoship_courier', true);
            $courier_name = get_courier_name($courier_id);
            $awb_data = [
                'courier'   => $courier_name,
                'awbList'   => [$awb_id]
                ];
            $data = json_encode($awb_data);
            $response = (new InnoshipAPI)->trackOrder($data);
            $rasp = json_decode($response);
            foreach ($rasp as $resp){
                $history = $resp->history;
                $new_status = $history[0]->clientStatusId;
            }
            update_post_meta($ord->post_id, 'awb_status', $new_status);
        }
    }
}