<?php
add_action('admin_menu', 'add_generate_page_innoship');
function add_generate_page_innoship(){
    add_submenu_page(
        'Genereaza AWB Innoship', 
        'Genereaza AWB Innoship', 
         null,
        'manage_woocommerce', 
        'generate-awb-innoship', 
        'generate_page_innoship', 
        null
    );
}
function generate_page_innoship(){
    $settings = (array) get_option( 'dbx-innoship-plugin-settings' );
    $validate = isset($settings['dbx_innoship_validate']) ? esc_attr($settings['dbx_innoship_validate']) : '';
    /*
    if($validate != 'succes'){
        die('Licenta invalida!');
    }
    */
    $api_key= isset($settings['dbx_innoship_api_key']) ? esc_attr($settings['dbx_innoship_api_key']) : '';
    $client_location = isset($settings['dbx_innoship_external_location']) ? esc_attr($settings['dbx_innoship_external_location']) : '';
    $service_id = isset($settings['dbx_innoship_serviciu']) ? esc_attr($settings['dbx_innoship_serviciu']) : '';
    $livrare_sambata = isset($settings['dbx_innoship_ls']) ? esc_attr($settings['dbx_innoship_ls']) : '';
    $deschidere_colet = isset($settings['dbx_innoship_dc']) ? esc_attr($settings['dbx_innoship_dc']) : '';
    $nr_colete = isset($settings['dbx_innoship_nr_colete']) ? esc_attr($settings['dbx_innoship_nr_colete']) : '';
    /*
    if (empty($api_key)){
        echo '<div class="wrap"><h1>Woocommerce DBX - Innoship</h1><br><h2>Licența dvs. pentru modulul Woocommerce DBX - Innoship a expirat.</h2> Va rugam dati click <a href="/wp-admin/options-general.php?page=dbx-innoship-settings-page'.'"> aici</a> pentru a verifica licența dvs.</div>';
        exit;
    }
    */
    $order = wc_get_order($_GET['order_id']);
    if(!$order){
        die('Invalid order id');   
    }
    $observatii = '';
    if ($order->get_customer_note() != '') {
    $observatii = $order->get_customer_note();
    }
    $weight = 0;
    $contents = [];
    $height = 0;
    $width = 0;
    $length = 0;
    $totalheight = [];
    $totallength = [];
    $items = $order->get_items();
    foreach($items as $k=>$item){
        $product = $item->get_product();   
        $name = $product->get_name();
        $sku = $product->get_sku();
        if(empty($sku)){
            $sku = $product->get_id();
        }
        $total = $item->get_total();
        $total = str_replace(",",".", $total);
        $contents []= $item->get_quantity().' x '.$name;
        if ( !$product->is_virtual()) {
            if(!empty($product->get_weight())){
                $weight += $product->get_weight() * $item->get_quantity();    
            }
            else{
                $weight = 1;
            }
            $height       = (int) $product->get_height();
            $totalheight[] = $height;
            $length       = (int) $product->get_length();
            $totallength[] = $length;
        }
    }
    $height = max($totalheight);
    $length = max($totallength);
    if($height == 0){ $height = 10; }
    if($length == 0){ $length = 10; }
    if($width == 0) { $width  = 10; }
    $weight_type = get_option('woocommerce_weight_unit');
    if ($weight_type == 'g') { $weight = $weight / 1000; }
    $contents = implode(', ', $contents);
    $platitor = isset($settings['dbx_innoship_platitor']) ? esc_attr($settings['dbx_innoship_platitor']) : '';
    if($platitor == 'Sender'){ $ramburs = $order->get_total(); }
    if($platitor == 'Recipient'){ $ramburs = number_format((float) $order->get_total() - $order->get_shipping_total() - $order->get_shipping_tax(), wc_get_price_decimals(), '.', ''); }
    if($order->get_payment_method() == 'cod'){
        $ramburs = $ramburs;
    }
    else {
        $ramburs = 0;
    }
    $contactPerson = $order->get_shipping_first_name().' '.$order->get_shipping_last_name();
    if($order->get_shipping_company()){
        $nume = $order->get_shipping_company();
    }
    else{
        $nume = $contactPerson;
    }
    $adresa = $order->get_shipping_address_1() . ' ' . $order->get_shipping_address_2();
    $county = remove_accents(dbx_get_counties($order->get_shipping_state()));
    $innoship_pudo = $order->get_meta('dbx_innoship_pickup_pudo');
    include_once(plugin_dir_path(__FILE__) . '/innoship-awb.php');
}
add_action('admin_notices', 'dbx_innoship_admin_notices', 99);
function dbx_innoship_admin_notices(){
    if(get_option('dbx_innoship_error')){
        ?>
        <div class="notice notice-success is-dismissible">
        <p><?php _e( get_option( 'dbx_innoship_error' ), 'woo-dbx-innoship' ); ?></p>
        </div>
        <?php
        delete_option('dbx_innoship_error');
    }
    if(get_option('innoship_delete_success')){
        ?>
        <div class="notice notice-success is-dismissible">
        <p><?php _e( get_option( 'innoship_delete_success' ), 'woo-dbx-innoship' ); ?></p>
        </div>
        <?php
        delete_option('innoship_delete_success');
    }
    if(get_option('innoship_succes_delete_error')){
        ?>
        <div class="notice notice-success is-dismissible">
        <p><?php _e( get_option( 'innoship_succes_delete_error' ), 'woo-dbx-innoship' ); ?></p>
        </div>
        <?php
        delete_option('innoship_succes_delete_error');
    }
}
add_action('add_meta_boxes', 'dbx_metabox_innoship');
function dbx_metabox_innoship(){
    add_meta_box(
		'dbx_metabox_innoship', 
		esc_html__('AWB Innoship', 'woo-dbx-innoship'),
		'dbx_metabox_innoship_html',
		'shop_order',
		'side', 
		'core'
	);    
}
function dbx_metabox_innoship_html($post){
    $awb_no = get_post_meta($post->ID, 'awb_innoship', true ); 
    $status_id = get_post_meta($post->ID, 'awb_status', true ); 
    $courier = get_post_meta($post->ID, 'innoship_courier', true ); 
    $tracking = get_post_meta($post->ID, 'awb_tracking_url', true ); 
    $print_url = plugin_dir_url(__DIR__).'includes/print.php?&order_id='.$post->ID;
    $delete_url = plugin_dir_url(__DIR__).'includes/delete.php?&order_id='.$post->ID;
    if($awb_no){
        $courier_name = get_courier_name($courier);
        $status = get_awb_status_name($status_id);
        ?>
		<div class="order_data_column_container">
			<div style="display:flex;">
			<p style="margin-right:5%;"> Curier: <b><?php echo $courier_name;?></b></p>
			<p> Nr. AWB: <b><?php echo $awb_no;?></b></p>
			</div>
			<div style="display:flex;gap:10px;width:100%;flex-flow: row wrap;">
			<a style="flex: 1 auto;text-align: center;" class="button-primary" href="<?php echo $print_url;?>" target="_blank" ><?php echo esc_html__('Tiparește','woo-dbx-innoship');?></a>    
            <a style="flex: 1 auto;text-align: center;" class="button-primary" href="<?php echo $tracking;?>" target="_blank" ><?php echo esc_html__('Urmărește AWB','woo-dbx-innoship');?></a>				
            <a style="flex: 1 auto;text-align: center;" class="button-primary" href="<?php echo $delete_url;?>"><?php echo esc_html__('Șterge AWB','woo-dbx-innoship');?></a>
			</div>
			<div class="innoship_notice" style="background: #C8D7E1;border-radius: 4px;padding: 5px;margin-top:5px;box-shadow: 0 2px 4px #ccc;">
			<div class="innoship-notice" style="font-size: 12px;line-height: 1.85;padding-left: 5px;"><span class="dashicons dashicons-info"></span><span>Status: <?php echo $status ;?></span></div>
			</div>
		</div>
        <?php
    }
    else {
        ?>
		<div class="order_data_column_container">
			<div style="display:flex;gap:10px;width:100%;flex-flow: row wrap;">
			<a style="flex: 1 auto;text-align: center;" class="button-primary" href="admin.php?page=generate-awb-innoship&order_id=<?php echo $post->ID ;?>"><?php echo esc_html__('Generează AWB','woo-dbx-innoship');?></a>    
			</div>
		</div>
        <?php
    }
}
add_filter('manage_edit-shop_order_columns', 'innoship_order_table_column', 10);
function innoship_order_table_column($cols){
    $new_cols = $cols;
    if (!is_array($cols)) {
        $cols = array();
    }
    $new_cols['awb_innoship_col'] = 'Innoship AWB';
    return $new_cols;
}
add_action('manage_shop_order_posts_custom_column', 'innoship_order_table_column_data', 6); 
function innoship_order_table_column_data($column){
    global $post;
    if($column == 'awb_innoship_col'){
    $awb_no = get_post_meta($post->ID, 'awb_innoship', true ); 
    $status_id = get_post_meta($post->ID, 'awb_status', true );
    $courier = get_post_meta($post->ID, 'innoship_courier', true ); 
    $tracking = get_post_meta($post->ID, 'awb_tracking_url', true );  
    $print_url = plugin_dir_url(__DIR__).'includes/print.php?&order_id='.$post->ID;
    $delete_url = plugin_dir_url(__DIR__).'includes/delete.php?&order_id='.$post->ID.'&bulk=1';
    if($awb_no){
        $courier_name = get_courier_name($courier);
        $status = get_awb_status_name($status_id);
        ?>
        <a class="button-download tips" data-tip="<?php echo esc_html__('Printează AWB','woo-dbx-innoship');?>" href="<?php echo $print_url;?>" style="cursor: pointer;border-radius:4px;display: inline-block;width:60%;text-align:center;height:30px;background-color:#C6E1C6;box-shadow: 0 2px 4px #ccc;color: #5b841b;line-height: 2.3em;font-weight: 600;font-size: 14px;" target="_blank"><span class="dashicons dashicons-pdf" style="font-size: 20px;line-height: 1.6em;margin-left: 5px;display: inherit;vertical-align: middle;height: 20px;width: 20px;float: left;"></span><?php echo $awb_no;?></a>
        <a class="button-remove tips" data-tip="<?php echo esc_html__('Șterge AWB','woo-dbx-innoship');?>" href="<?php echo $delete_url;?>" style="cursor: pointer;border-radius: 4px;display: inline-block;width: 18%;text-align: center;height: 30px;background-color: #F0F0F1;box-shadow: 0 2px 4px #ccc;color: #EA2024;line-height: 2.4em;"><span class="dashicons dashicons-no" style="font-size: 25px;display: inherit;vertical-align: middle;height: 25px;width: 25px;"></span></a>
        <a class="button-remove tips" data-tip="<?php echo esc_html__('Urmărește AWB','woo-dbx-innoship');?>" href="<?php echo $tracking;?>" style="cursor: pointer;border-radius: 4px;display: inline-block;width: 18%;text-align: center;height: 30px;background-color: #F0F0F1;box-shadow: 0 2px 4px #ccc;color: #2271b1;line-height: 2.4em;" target="_blank"><span class="dashicons dashicons-location-alt" style="font-size: 25px;display: inherit;vertical-align: middle;height: 25px;width: 25px;line-height: 0.8em;"></span></a>
        <div class="innoship_notice" style="background: #C8D7E1;border-radius: 4px;padding: 5px;margin-top:5px;box-shadow: 0 2px 4px #ccc;">
            <div class="innoship-notice" style="font-size: 12px;line-height: 1.85;padding-left: 5px;">Curier: <?php echo $courier_name;?></span></div>
            <div class="innoship-notice" style="font-size: 12px;line-height: 1.85;padding-left: 5px;"><span class="dashicons dashicons-info"></span><span>Status: <?php echo $status ;?></span></div>
        </div>
        <?php
    }
    else{
        $generate_url = esc_url(add_query_arg(['innoship_generate_awb'=> $post->ID]));
        ?>
        <a class="button-generate tips" style="cursor: pointer;border:1px solid #2271b1; border-radius:4px;display: block;width:100%;text-align:center;height:35px;background-color:white;box-shadow: 0 2px 4px #ccc;" data-tip="<?php echo esc_html__('Generează AWB','woo-dbx-innoship');?>" href="<?php echo $generate_url;?>"><img src="<?php echo plugin_dir_url(__FILE__).'assets/logo.svg';?>" style="height: 30px;vertical-align: middle;height: 95% !important;object-fit: contain;width: 100%;margin: 0;image-rendering: -webkit-optimize-contrast;"/></a>
        <?php
    }
    }
}
function innoship_generate_awb($bulk_id = NULL){
    global $wpdb;
    $order_id = get_query_var('innoship_generate_awb');
    if($bulk_id){
        $order_id = $bulk_id;
    }
    if($order_id){
      $awb_no = get_post_meta($order_id, 'awb_innoship', true);
      $settings = (array) get_option( 'dbx-innoship-plugin-settings' );
      $validate = isset($settings['dbx_innoship_validate']) ? esc_attr($settings['dbx_innoship_validate']) : '';
      $api_key= isset($settings['dbx_innoship_api_key']) ? esc_attr($settings['dbx_innoship_api_key']) : '';
      $client_location = isset($settings['dbx_innoship_external_location']) ? esc_attr($settings['dbx_innoship_external_location']) : '';
      $service_id = isset($settings['dbx_innoship_serviciu']) ? esc_attr($settings['dbx_innoship_serviciu']) : '';
      $tip_plata = isset($settings['dbx_innoship_tip_plata']) ? esc_attr($settings['dbx_innoship_tip_plata']) : '';
      $platitor = isset($settings['dbx_innoship_platitor']) ? esc_attr($settings['dbx_innoship_platitor']) : '';
      $livrare_sambata = isset($settings['dbx_innoship_ls']) ? esc_attr($settings['dbx_innoship_ls']) : '';
      $deschidere_colet = isset($settings['dbx_innoship_dc']) ? esc_attr($settings['dbx_innoship_dc']) : '';
      $nr_colete = isset($settings['dbx_innoship_nr_colete']) ? esc_attr($settings['dbx_innoship_nr_colete']) : '';
      $update = isset($settings['dbx_innoship_update_comanda']) ? esc_attr($settings['dbx_innoship_update_comanda']) : '';
      if($awb_no) return;
      /*
      if ($validate != 'succes'){
        add_option( 'dbx_innoship_error', 'Licența dvs. pentru modulul Woocommerce DBX - Innoship a expirat!');
        return;
      }
      */
      try{
        $order = wc_get_order($order_id);
        $observatii = '';
        if ($order->get_customer_note() != '') {
        $observatii = $order->get_customer_note();
        }
        $weight = 0;
        $contents = [];
        $height = 0;
        $width = 0;
        $length = 0;
        $totalheight = [];
        $totallength = [];
        $items = $order->get_items();
        foreach($items as $k=>$item){
        $product = $item->get_product();   
        $name = $product->get_name();
        $sku = $product->get_sku();
        if(empty($sku)){
            $sku = $product->get_id();
        }
        $total = $item->get_total();
        $total = str_replace(",",".", $total);
        $contents []= $item->get_quantity().' x '.$name;
        if ( !$product->is_virtual()) {
            if(!empty($product->get_weight())){
            $weight += $product->get_weight() * $item->get_quantity();    
            }
            else{
            $weight = 1;
            }
            $height       = (int) $product->get_height();
            $totalheight[] = $height;
            $length       = (int) $product->get_length();
            $totallength[] = $length;
        }
        }
        $height = max($totalheight);
        $length = max($totallength);
        if($height == 0){ $height = 10; }
        if($length == 0){ $length = 10; }
        if($width == 0) { $width  = 10; }
        $weight_type = get_option('woocommerce_weight_unit');
        if ($weight_type == 'g') { $weight = $weight / 1000; }
        $contents = implode(', ', $contents);
        if($platitor == 'Sender'){ $ramburs = $order->get_total(); }
        if($platitor == 'Recipient'){ $ramburs = number_format((float) $order->get_total() - $order->get_shipping_total() - $order->get_shipping_tax(), wc_get_price_decimals(), '.', ''); }
        if($order->get_payment_method() == 'cod'){
        $ramburs = $ramburs;
        }
        else {
        $ramburs = 0;
        }
        if($tip_plata == 'bank'){
        $ramburs_banca  = $ramburs;
        $moneda_banca   = $order->get_currency();
        }
        if($tip_plata == 'cod'){
        $ramburs_cod  = $ramburs;
        $moneda_cod   = $order->get_currency();
        }
        $contactPerson = $order->get_shipping_first_name().' '.$order->get_shipping_last_name();
        if($order->get_shipping_company()){
        $nume = $order->get_shipping_company();
        }
        else{
        $nume = $contactPerson;
        }
        $adresa = $order->get_shipping_address_1() . ' ' . $order->get_shipping_address_2();
        $county = remove_accents(dbx_get_counties($order->get_shipping_state()));
        $innoship_pudo = $order->get_meta('dbx_innoship_pickup_pudo');
        if( $innoship_pudo ){
        $serviceId = 3;
        $customer = [
        'name'              => $nume,
        'contactPerson'     => $contactPerson,
        'phone'             => $order->get_billing_phone(),
        'email'             => null,
        'fixedLocationId'   => $innoship_pudo,
        'courierFixedLocationId'    => null
        ];
        }
        else{
        $customer = [
        'name'              => $nume,
        'contactPerson'     => $contactPerson,
        'country'           => 'RO',
        'countryName'       => null,
        'countyId'          => null,
        'localityId'        => null,
        'countryId'         => null,
        'countyName'        => $county,
        'localityName'      => $order->get_shipping_city(),
        'addressText'       => $adresa,
        'postalCode'        => $order->get_shipping_postcode(),
        'phone'             => $order->get_billing_phone(),
        'email'             => null,
        'fixedLocationId'   => null,
        'courierFixedLocationId'    => null
        ];
        $serviceId = $service_id;    
        }
        $parcels = [
        'sequenceNo'    => 1,
        'size'          => [
            'width'     => $width,
            'height'    => $height,
            'length'    => $length
            ],
        'weight'        => $weight,
        'type'          => 'Parcel',
        'reference1'    => 'Referinta 1',
        'reference2'    => null,
        'customerBarcode'=> null
        ];    
        $awb_content = [
        'envelopeCount'     => 0,
        'parcelsCount'      => $nr_colete,
        'palettesCount'     => 0,
        'totalWeight'       => $weight,
        'contents'          => $contents,
        'package'           => 'box',
        'oversizedPackage'  => false,
        'parcels'           => [$parcels]
        ];
        $awb_extra = [
        'bankRepaymentAmount'   => isset($ramburs_banca) ? esc_attr($ramburs_banca) : null,
        'bankRepaymentCurrency' => isset($moneda_banca) ? esc_attr($moneda_banca) : null,
        'cashOnDeliveryAmount'  => isset($ramburs_cod) ? esc_attr($ramburs_cod) : null,
        'cashOnDeliveryAmountCurrency'  => isset($moneda_cod) ? esc_attr($moneda_cod) : null,
        'declaredValueAmount'       => null,
        'declaredValueAmountCurrency'=> null,
        'openPackage'   => false,
        'saturdayDelivery'  => null,
        'insuranceAmount'   => null,
        'insuranceAmountCurrency'   => null,
        'reference1'        => get_bloginfo('name'),
        'reference2'        => $order->get_id(),
        'reference3'        => null,
        'reference4'        => null,
        'returnOfDocuments' => null,
        'returnOfDocumentsComment'=> null,
        'returnPackage'     => null,
        'bank'              => null,
        'bankIBAN'          => null
        ];
        $awb_data = [
        'serviceId'     => $serviceId,
        'courierId'     => null,
        'shipmentDate'  => current_time("Y-m-d"),
        'addressFrom'   => null,
        'addressTo'     => $customer,
        'payment'       => $platitor,
        'content'       => $awb_content,
        'extra'         => $awb_extra,
        'parameters'    => [
            'async'                 => true,
            'getParcelsBarcodes'    => false,
            'includeCourierResponse'=> false,
            'includePriceBreakdown' => false
            ],
        'externalClientLocation'    => $client_location,
        'externalOrderId'           => $order->get_id(),
        'metadata'                  => null,
        'sourceChannel'             => get_bloginfo('name'),
        'observation'               => isset($observatii) ? esc_attr($observatii) : null,
        'customAttributes'          => null
        ];
        $data = json_encode($awb_data);
        $response = (new InnoshipAPI)->sendOrder($data);
        //echo '<pre>';
        //print_r($response);
        //echo '</pre>';
        $rasp = json_decode($response);
        if($rasp->clientOrderId){
            $nr_awb = $rasp->courierShipmentId;
            $tracking = $rasp->trackPageUrl;
            $courier_id = $rasp->courier;
            $courier_name = get_courier_name($courier_id);    
            update_post_meta($order_id, 'awb_innoship', $nr_awb);
            update_post_meta($order_id, 'awb_status', '1');
            update_post_meta($order_id, 'innoship_courier', $courier_id);
            update_post_meta($order_id, 'awb_tracking_url', $tracking);
            if($update =="Da") $order->update_status( 'completed' );
            add_option( 'dbx_innoship_error', 'AWB GENERAT');
        }
        else{
            add_option( 'dbx_innoship_error', 'EROARE LA GENERAREA AWB-ULUI!');
        }
      }
      catch (Exception $e) {
                $e->getMessage();
      }
    }
}
add_filter('query_vars', function ($vars) {
    $vars[] = "innoship_generate_awb";
    return $vars;
});
add_action('admin_notices','innoship_generate_awb');
add_action( 'woocommerce_order_status_changed', 'innoship_awb_autogenerate', 99, 3);
function innoship_awb_autogenerate($order_id, $old_status, $new_status){
    $settings = (array) get_option( 'dbx-innoship-plugin-settings' );
    $auto = isset($settings['dbx_innoship_autogenerate']) ? esc_attr($settings['dbx_innoship_autogenerate']) : '';
    if($auto != "Da") return;
    if($new_status !== 'processing') return; 
    set_query_var('innoship_generate_awb', $order_id);
    innoship_generate_awb();
}
add_action( 'admin_footer', 'innoship_bulk_actions');
function innoship_bulk_actions() {
	global $post_type;

	if ( 'shop_order' == $post_type ) {	
        wp_enqueue_script( 'innoship_bulk_admin_js', plugin_dir_url(__FILE__).'assets/js/bulkGenerate.js', array('jquery'), '1.0.2');    
	}
}
add_action( 'woocommerce_email_before_order_table', 'innoship_send_awb_details_email', 20, 4 );
function innoship_send_awb_details_email($order, $sent_to_admin, $plain_text, $email){
    if ( $email->id == 'customer_completed_order' ) {
		$awb_id = $order->get_meta('awb_innoship');
		$courier_id = $order->get_meta('innoship_courier');
		$courier_name = get_courier_name($courier_id);
		$tracking = $order->get_meta('awb_tracking_url');
		$settings = (array) get_option('dbx-innoship-plugin-settings');
		$update = isset($settings['dbx_innoship_update_mail']) ? esc_attr($settings['dbx_innoship_update_mail']) : '';
		$email_continut = isset($settings['dbx_innoship_text_mail']) ? esc_attr($settings['dbx_innoship_text_mail']) : '';
		$buton = '<a href="'.$tracking.'">URMARESTE COMANDA</a>';	
		$continut = str_replace(array('[nr-awb]', '[buton-urmarire]', '[nume-curier]'), array( $awb_id, $buton, $courier_name), $email_continut);
		if ($awb_id && $email_continut && $update == 'Da'){
			echo $continut;
		}
    }
}
include_once(plugin_dir_path(__FILE__) .'/cron_status.php');