<?php
//define('WP_USE_THEMES', false);
require '../../../../wp-load.php';
$order = wc_get_order($_GET['order_id']);
if(!$order){
    die('Invalid order id');   
}
$settings = (array) get_option( 'dbx-innoship-plugin-settings' );
$client_location = isset($settings['dbx_innoship_external_location']) ? esc_attr($settings['dbx_innoship_external_location']) : '';
$service_id = isset($settings['dbx_innoship_serviciu']) ? esc_attr($settings['dbx_innoship_serviciu']) : '';
$update = isset($settings['dbx_innoship_update_comanda']) ? esc_attr($settings['dbx_innoship_update_comanda']) : '';
$tip_plata = $_POST['tip_plata'];
if($tip_plata == 'bank'){
    $ramburs_banca  = $_POST['valoare'];
    $moneda_banca   = $order->get_currency();
}
if($tip_plata == 'cod'){
    $ramburs_cod  = $_POST['valoare'];
    $moneda_cod   = $order->get_currency();
}
$innoship_pudo = $order->get_meta('dbx_innoship_pickup_pudo');
if( $innoship_pudo ){
      $serviceId = 3;
      $customer = [
        'name'              => $_POST['destinatar'],
        'contactPerson'     => $_POST['contact_person'],
        'phone'             => $_POST['telefon'],
        'email'             => null,
        'fixedLocationId'   => $innoship_pudo,
        'courierFixedLocationId'    => null
        ];
    }
else{
    $customer = [
    'name'              => $_POST['destinatar'],
    'contactPerson'     => $_POST['contact_person'],
    'country'           => 'RO',
    'countryName'       => null,
    'countyId'          => null,
    'localityId'        => null,
    'countryId'         => null,
    'countyName'        => $_POST['judet'],
    'localityName'      => $_POST['oras'],
    'addressText'       => $_POST['adresa'],
    'postalCode'        => $_POST['cod_postal'],
    'phone'             => $_POST['telefon'],
    'email'             => null,
    'fixedLocationId'   => null,
    'courierFixedLocationId'    => null
    ];
    $serviceId = $service_id;    
}
$total_weight = 0;
for ($i = 1; $i <= $_POST['nr_colete']; $i++) {
    $width = round(($_POST['latime'] / $_POST['nr_colete']), 2);
    $length = round(($_POST['lungime'] / $_POST['nr_colete']), 2);
    $height = round(($_POST['inaltime'] / $_POST['nr_colete']), 2);
    $weight = round(($_POST['greutate'] / $_POST['nr_colete']), 2);
    $total_weight = $total_weight + $weight;
    $parcelz []= [
    'sequenceNo'    => $i,
    'size'          => [
        'width'     => $width,
        'height'    => $height,
        'length'    => $length
        ],
    'weight'        => $weight,
    'type'          => 'Parcel',
    'reference1'    => 'Colet '.$i,
    'reference2'    => null,
    'customerBarcode'=> ''
    ];
}
$parcels = [
    'sequenceNo'    => 1,
    'size'          => [
        'width'     => $_POST['latime'],
        'height'    => $_POST['inaltime'],
        'length'    => $_POST['lungime']
        ],
    'weight'        => $_POST['greutate'],
    'type'          => 'Parcel',
    'reference1'    => 'Referinta 1',
    'reference2'    => null,
    'customerBarcode'=> ''
    ];    
$awb_content = [
    'envelopeCount'     => $_POST['nr_plicuri'],
    'parcelsCount'      => $_POST['nr_colete'],
    'palettesCount'     => 0,
    'totalWeight'       => $total_weight,
    'contents'          => $_POST['continut'],
    'package'           => 'box',
    'oversizedPackage'  => false,
    'parcels'           => $parcelz
    ];
$awb_extra = [
    'bankRepaymentAmount'   => isset($ramburs_banca) ? esc_attr($ramburs_banca) : null,
    'bankRepaymentCurrency' => isset($moneda_banca) ? esc_attr($moneda_banca) : null,
    'cashOnDeliveryAmount'  => isset($ramburs_cod) ? esc_attr($ramburs_cod) : null,
    'cashOnDeliveryAmountCurrency'  => isset($moneda_cod) ? esc_attr($moneda_cod) : null,
    'declaredValueAmount'       => null,
    'declaredValueAmountCurrency'=> null,
    'openPackage'   => false,
    'saturdayDelivery'  => null,
    'insuranceAmount'   => null,
    'insuranceAmountCurrency'   => null,
    'reference1'        => $_POST['ref1'],
    'reference2'        => $_POST['ref2'],
    'reference3'        => $_POST['ref3'],
    'reference4'        => $_POST['ref4'],
    'returnOfDocuments' => null,
    'returnOfDocumentsComment'=> null,
    'returnPackage'     => null,
    'bank'              => null,
    'bankIBAN'          => null
    ];
$awb_data = [
    'serviceId'     => $serviceId,
    'courierId'     => '',
    'shipmentDate'  => date("Y-m-d"),
    'addressFrom'   => '',
    'addressTo'     => $customer,
    'payment'       => $_POST['platitor'],
    'content'       => $awb_content,
    'extra'         => $awb_extra,
    'parameters'    => [
        'async'                 => true,
        'getParcelsBarcodes'    => false,
        'includeCourierResponse'=> false,
        'includePriceBreakdown' => false
        ],
    'externalClientLocation'    => $client_location,
    'externalOrderId'           => $order->get_id(),
    'metadata'                  => 'extra data info',
    'sourceChannel'             => get_bloginfo('name'),
    'observation'               => $_POST['observatii'],
    'customAttributes'          => null
    ];
$data = json_encode($awb_data);
$response = (new InnoshipAPI)->sendOrder($data);
$rasp = json_decode($response);
/*
echo '<pre>';
print_r($rasp);
echo '</pre>';
exit;
*/
if($rasp->clientOrderId){
    $nr_awb = $rasp->courierShipmentId;
    $tracking = $rasp->trackPageUrl;
    $courier_id = $rasp->courier;
    $courier_name = get_courier_name($courier_id);    
    update_post_meta($_GET['order_id'], 'awb_innoship', $nr_awb);
    update_post_meta($_GET['order_id'], 'awb_status', '1');
    update_post_meta($_GET['order_id'], 'innoship_courier', $courier_id);
    update_post_meta($_GET['order_id'], 'awb_tracking_url', $tracking);
    if($update =="Da") $order->update_status( 'completed' );
    add_option( 'dbx_innoship_error', 'Awb-ul '.$nr_awb .' a fost generat cu succes.');
    header('Location: ' . admin_url() . 'post.php?post=' . $_GET['order_id'] . '&action=edit');
}
else{
add_option( 'dbx_innoship_error', 'Eroare la generarea awb-ului.' );
header('Location: ' . admin_url() . 'post.php?post=' . $_GET['order_id'] . '&action=edit');
}