<?php
class InnoshipAPI {
    private function callAPI($endpoint = NULL, $method = NULL){
        $settings = (array) get_option( 'dbx-innoship-plugin-settings' );
        $api_key = $settings['dbx_innoship_api_key'];
        if($api_key){
            $auth = 'X-Api-Key: '.$api_key;
            $url = 'https://api.innoship.com/api/'.$endpoint; 
            $curl = curl_init();
            curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => $method,
            //CURLOPT_POSTFIELDS => $data,
            CURLOPT_HTTPHEADER => array(
             'api-version: 1.0', $auth, 'accept: */*'
            ),
            ));
            $response = curl_exec($curl);
            curl_close($curl);
            return $response;
        }
    }
    public function getClientLocations(){
        $endpoint = 'Location/ClientLocations';
        $method   = 'GET';
        return $this->callAPI($endpoint, $method);
    }
    public function getCounties(){
        $method   = 'GET';
        $endpoint = 'Location/Counties/RO';
        return $this->callAPI($endpoint, $method);
    }
    public function getFixedLocations($data = NULL){
        $method   = 'GET';
        $params = http_build_query( $data );
        $endpoint = 'Location/FixedLocations'.'?'.$params;
        $response = json_decode($this->callAPI($endpoint, $method));
        return $response;
    }
    public function sendOrder($data = NULL){
        $settings = (array) get_option( 'dbx-innoship-plugin-settings' );
        $api_key = $settings['dbx_innoship_api_key'];
        if($api_key){
            $auth = 'X-Api-Key: '.$api_key;
            $header = [
                ''
                ];
            $url = 'https://api.innoship.com/api/order?api-version=1.0'; 
            $curl = curl_init();
            curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => $data,
            CURLOPT_HTTPHEADER => array(
                'api-version=1.0', $auth, 'accept: */*', 'Content-Type: text/json'
            ),
            ));
            $response = curl_exec($curl);
            curl_close($curl);
            return $response;
        }
    }
    public function trackOrder($data = NULL){
        $settings = (array) get_option( 'dbx-innoship-plugin-settings' );
        $api_key = $settings['dbx_innoship_api_key'];
        if($api_key){
            $auth = 'X-Api-Key: '.$api_key;
            $header = [
                ''
                ];
            $url = 'https://api.innoship.com/api/Track/by-awb/with-return?api-version=1.0'; 
            $curl = curl_init();
            curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => $data,
            CURLOPT_HTTPHEADER => array(
                'api-version=1.0', $auth, 'accept: */*', 'Content-Type: text/json'
            ),
            ));
            $response = curl_exec($curl);
            curl_close($curl);
            return $response;
        }
    }
    public function deleteOrder($id = NULL, $awbNo = NULL){
        $method   = 'DELETE';
        $endpoint = 'order/'.$id.'/awb/'.$awbNo;
        return $this->callAPI($endpoint, $method);
    }
    public function printOrder($id = NULL, $awbNo = NULL, $data = NULL){
        $method   = 'GET';
        $params = http_build_query( $data );
        $endpoint = 'Label/by-courier/'.$id.'/awb/'.$awbNo.'?'.$params;
        return $this->callAPI($endpoint, $method);
    }
}